gtkmm: Gdk::EventTouch Class Reference

gtkmm 3.91.0

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Related Functions | List of all members
Gdk::EventTouch Class Reference

Generated during an attached touchscreen is touched. More...

`#include <gdkmm/event.h>`

Inheritance diagram for Gdk::EventTouch:
[legend]

## Public Member Functions
| EventTouch ()
| Creates an invalid event object. More...
| EventTouch (GdkEventTouch* gobject, bool make_a_copy=false)
| Wraps a C event instance. More...
void | swap (EventTouch& other) noexcept
GdkEventTouch* | gobj ()
| Provides access to the underlying C instance. More...
const GdkEventTouch* | gobj () const
| Provides access to the underlying C instance. More...
GdkEventTouch* | gobj_copy () const
| Provides access to the underlying C instance. More...
guint32 | get_time () const
| Returns the timestamp of the event in milliseconds. More...
ModifierType | get_state () const
| Returns a bit mask representing the state of the modifier keys (e.g. More...
double | get_x () const
| Returns the X coordinate of the pointer relative to the window. More...
double | get_y () const
| Returns the Y coordinate of the pointer relative to the window. More...
double | get_root_x () const
| Returns the X coordinate of the pointer relative to the root screen. More...
double | get_root_y () const
| Returns the Y coordinate of the pointer relative to the root screen. More...
bool | get_axis (Gdk::AxisUse axis_use, double& value) const
| Extract the axis value for a particular axis use from an event structure. More...
const Gdk::EventSequence* | get_event_sequence () const
| Returns the event sequence that the event belongs to. More...
bool | get_is_emulating_pointer () const
| Returns `true` if the event should be used for emulating pointer event. More...
Glib::RefPtr< Gdk::Device > | get_device ()
| Returns the device where the event originated from. More...
Glib::RefPtr< const Gdk::Device > | get_device () const
Public Member Functions inherited from Gdk::Event
| Event ()
| Creates an invalid event object. More...
| Event (GdkEvent* gobject, bool make_a_copy=false)
| Wraps a C event instance. More...
| Event (const Event& other)
Event& | operator= (const Event& other)
| Event (Event&& other) noexcept
Event& | operator= (Event&& other) noexcept
| ~Event () noexcept
void | swap (Event& other) noexcept
GdkEvent* | gobj ()
| Provides access to the underlying C instance. More...
const GdkEvent* | gobj () const
| Provides access to the underlying C instance. More...
GdkEvent* | gobj_copy () const
| Provides access to the underlying C instance. More...
Event::Type | get_event_type () const
| Retrieves the type of the event. More...
Glib::RefPtr< Gdk::Window > | get_window ()
| Returns the window which received the event. More...
Glib::RefPtr< const Gdk::Window > | get_window () const
bool | is_send_event () const
| Returns `true` if the event was sent explicitly (e.g. More...
Glib::RefPtr< Screen > | get_screen ()
| Returns the screen for the event. More...
Glib::RefPtr< const Screen > | get_screen () const
| Returns the screen for the event. More...
Glib::RefPtr< Seat > | get_seat ()
| Returns the Gdk::Seat this event was generated for. More...
Glib::RefPtr< const Seat > | get_seat () const
| Returns the Gdk::Seat this event was generated for. More...
void | put ()
| Appends a copy of the given event onto the front of the event queue for event->any.window’s display, or the default event queue if event->any.window is `nullptr`. More...

## Related Functions
(Note that these are not member functions.)
void | swap (EventTouch& lhs, EventTouch& rhs) noexcept
const EventTouch& | wrap_event (const GdkEventTouch*& event)
| Wraps a C event instance without making unnecessary copy when the ownership can not be acquired. More...
EventTouch& | wrap_event (GdkEventTouch*& event)
| See wrap_event(const GdkEventTouch*& event). More...
Gdk::EventTouch | wrap (GdkEventTouch* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gdk::Event
void | swap (Event& lhs, Event& rhs) noexcept
const Event& | wrap_event (const GdkEvent*& event)
| Wraps a C event instance without making unnecessary copy when the ownership can not be acquired. More...
Event& | wrap_event (GdkEvent*& event)
| See wrap_event(const GdkEvent*& event). More...
Gdk::Event | wrap (GdkEvent* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Gdk::Event
enum | Type { Type::NOTHING = -1, Type::DELETE = 0, Type::DESTROY = 1, Type::EXPOSE = 2, Type::MOTION_NOTIFY = 3, Type::BUTTON_PRESS = 4, Type::DOUBLE_BUTTON_PRESS = 5, Type::TRIPLE_BUTTON_PRESS = 6, Type::BUTTON_RELEASE = 7, Type::KEY_PRESS = 8, Type::KEY_RELEASE = 9, Type::ENTER_NOTIFY = 10, Type::LEAVE_NOTIFY = 11, Type::FOCUS_CHANGE = 12, Type::CONFIGURE = 13, Type::MAP = 14, Type::UNMAP = 15, Type::PROPERTY_NOTIFY = 16, Type::SELECTION_CLEAR = 17, Type::SELECTION_REQUEST = 18, Type::SELECTION_NOTIFY = 19, Type::PROXIMITY_IN = 20, Type::PROXIMITY_OUT = 21, Type::DRAG_ENTER = 22, Type::DRAG_LEAVE = 23, Type::DRAG_MOTION = 24, Type::DRAG_STATUS = 25, Type::DROP_START = 26, Type::DROP_FINISHED = 27, Type::CLIENT_EVENT = 28, Type::VISIBILITY_NOTIFY = 29, Type::SCROLL = 31, Type::WINDOW_STATE = 32, Type::SETTING = 33, Type::OWNER_CHANGE = 34, Type::GRAB_BROKEN = 35, Type::DAMAGE = 36, Type::TOUCH_BEGIN = 37, Type::TOUCH_UPDATE = 38, Type::TOUCH_END = 39, Type::TOUCH_CANCEL = 40, Type::TOUCHPAD_SWIPE = 41, Type::TOUCHPAD_PINCH = 42, Type::PAD_BUTTON_PRESS = 43, Type::PAD_BUTTON_RELEASE = 44, Type::PAD_RING = 45, Type::PAD_STRIP = 46, Type::PAD_GROUP_MODE = 47, Type::EVENT_LAST = 48 }
| Specifies the type of the event. More...
Static Public Member Functions inherited from Gdk::Event
static void | set_show_events (bool show_events)
| Sets whether a trace of received events is output. More...
static bool | get_show_events ()
| Gets whether event debugging output is enabled. More...
static Event | get ()
| Checks all open displays for a Gdk::Event to process,to be processed on, fetching events from the windowing system if necessary. More...
static Event | peek ()
| If there is an event waiting in the event queue of some open display, returns a copy of it. More...
static bool | events_pending ()
| Checks if any events are ready to be processed for any display. More...

## Detailed Description

Generated during an attached touchscreen is touched.

get_event_type() will return one of Gdk::Event::Type::TOUCH_BEGIN, Gdk::Event::Type::TOUCH_UPDATE, Gdk::Event::Type::TOUCH_END or Gdk::Event::Type::TOUCH_CANCEL.

Touch events are grouped into sequences by means of the sequence field, which can also be obtained with get_event_sequence(). Each sequence begins with a Gdk::Event::Type::TOUCH_BEGIN event, followed by any number of Gdk::Event::Type::TOUCH_UPDATE events, and ends with a Gdk::Event::Type::TOUCH_END (or Gdk::Event::Type::TOUCH_CANCEL) event. With multitouch devices, there may be several active sequences at the same time.

Since gtkmm 3.90:

## Constructor & Destructor Documentation

Gdk::EventTouch::EventTouch | ( |  | ) |

Creates an invalid event object.

Calling any member functions is undefined behavior.

Gdk::EventTouch::EventTouch | ( | GdkEventTouch * | gobject,
|  | bool | make_a_copy = `false`
| ) |  |
| explicit

Wraps a C event instance.

This constructor either acquires ownership of gobject, or copies it.

Parameters

  gobject | Event to wrap.
  make_a_copy | If `false`, the ownership of gobject is acquired, otherwise, a copy is made.

## Member Function Documentation

bool Gdk::EventTouch::get_axis | ( | Gdk::AxisUse | axis_use,
|  | double & | value
| ) |  | const

Extract the axis value for a particular axis use from an event structure.

Parameters

  axis_use | The axis use to look for.
  value | Location to store the value found.

Returns
  `true` if the specified axis was found, otherwise `false`.

Glib::RefPtr<Gdk::Device> Gdk::EventTouch::get_device | ( |  | ) |

Returns the device where the event originated from.

Glib::RefPtr<const Gdk::Device> Gdk::EventTouch::get_device | ( |  | ) | const

const Gdk::EventSequence* Gdk::EventTouch::get_event_sequence | ( |  | ) | const

Returns the event sequence that the event belongs to.

bool Gdk::EventTouch::get_is_emulating_pointer | ( |  | ) | const

Returns `true` if the event should be used for emulating pointer event.

double Gdk::EventTouch::get_root_x | ( |  | ) | const

Returns the X coordinate of the pointer relative to the root screen.

double Gdk::EventTouch::get_root_y | ( |  | ) | const

Returns the Y coordinate of the pointer relative to the root screen.

ModifierType Gdk::EventTouch::get_state | ( |  | ) | const

Returns a bit mask representing the state of the modifier keys (e.g.

Control, Shift and Alt) and the pointer buttons.

guint32 Gdk::EventTouch::get_time | ( |  | ) | const

Returns the timestamp of the event in milliseconds.

double Gdk::EventTouch::get_x | ( |  | ) | const

Returns the X coordinate of the pointer relative to the window.

double Gdk::EventTouch::get_y | ( |  | ) | const

Returns the Y coordinate of the pointer relative to the window.

GdkEventTouch* Gdk::EventTouch::gobj | ( |  | ) |
| inline

Provides access to the underlying C instance.

const GdkEventTouch* Gdk::EventTouch::gobj | ( |  | ) | const
| inline

Provides access to the underlying C instance.

GdkEventTouch* Gdk::EventTouch::gobj_copy | ( |  | ) | const

Provides access to the underlying C instance.

The caller is responsible for freeing it with gdk_event_free(). Use when directly setting fields in structs.

void Gdk::EventTouch::swap | ( | EventTouch& | other | ) |
| noexcept

## Friends And Related Function Documentation

void swap | ( | EventTouch& | lhs,
|  | EventTouch& | rhs
| ) |  |
| related

Parameters

  lhs | The left-hand side
  rhs | The right-hand side

Gdk::EventTouch wrap | ( | GdkEventTouch * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy.

Returns
  A C++ instance that wraps this C instance.

const EventTouch& wrap_event | ( | const GdkEventTouch *& | event | ) |
| related

Wraps a C event instance without making unnecessary copy when the ownership can not be acquired.

The event pointer must not be deleted until last usage of the returned instance. Note, that this requirement applies to the pointer itself, in addition to the object it is pointing to.

EventTouch& wrap_event | ( | GdkEventTouch *& | event | ) |
| related

See wrap_event(const GdkEventTouch*& event).